var exec = require('cordova/exec');

const className = "MobileFirebaseAuthentication";

exports.getCurrentUser = function (success, error) {
    exec(success, error, className, 'getCurrentUser', []);
};

exports.signInWithPhoneAuth = function (arg0, success, error) {

    if (typeof arg0 !== 'object' || Array.isArray(arg0)) {
        error("Invalid arguments. Expected an object.");
        return;
    }
    var argsArray = [
        arg0.phoneNumber,
        arg0.setTimeout
    ];

    exec(success, error, className, 'signInWithPhoneAuth', argsArray);
};

exports.verifyCode = function (arg0, success, error) {

    if (typeof arg0 !== 'object' || Array.isArray(arg0)) {
        error("Invalid arguments. Expected an object.");
        return;
    }
    var argsArray = [
        arg0.code
    ];

    exec(success, error, className, 'verifyCode', argsArray);
};

exports.createUserWithEmailAndPassword = function (arg0, success, error) {

    if (typeof arg0 !== 'object' || Array.isArray(arg0)) {
        error("Invalid arguments. Expected an object.");
        return;
    }
    var argsArray = [
        arg0.email,
        arg0.password
    ];

    exec(success, error, className, 'createUserWithEmailAndPassword', argsArray);
};

exports.signInWithEmailAndPassword = function (arg0, success, error) {

    if (typeof arg0 !== 'object' || Array.isArray(arg0)) {
        error("Invalid arguments. Expected an object.");
        return;
    }
    var argsArray = [
        arg0.email,
        arg0.password
    ];

    exec(success, error, className, 'signInWithEmailAndPassword', argsArray);
};

exports.signInWithGoogle = function (arg0, success, error) {

    if (typeof arg0 !== 'object' || Array.isArray(arg0)) {
        error("Invalid arguments. Expected an object.");
        return;
    }
    var argsArray = [
        arg0.clientID
    ];

    exec(success, error, className, 'signInWithGoogle', argsArray);
};

exports.signInAnonymously = function (success, error) {
    exec(success, error, className, 'signInAnonymously', []);
};

exports.signOut = function (success, error) {
    exec(success, error, className, 'signOut', []);
};